################################################################################
#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
#  Read the zproject/README.md for information about making permanent changes. #
################################################################################

require 'ffi'
require_relative 'ffi/version'

module Malamute
  module FFI
    module LibC
      extend ::FFI::Library
      ffi_lib ::FFI::Platform::LIBC
      attach_function :free, [ :pointer ], :void, blocking: true
    end

    extend ::FFI::Library

    def self.available?
      @available
    end

    begin
      lib_name = 'libmlm'
      lib_dirs = ['/usr/local/lib', '/opt/local/lib', '/usr/lib64']
      env_name = "#{lib_name.upcase}_PATH"
      lib_dirs = [*ENV[env_name].split(':'), *lib_dirs] if ENV[env_name]
      lib_paths = lib_dirs.map { |path| "#{path}/#{lib_name}.#{::FFI::Platform::LIBSUFFIX}" }
      ffi_lib lib_paths + [lib_name]
      @available = true
    rescue LoadError
      warn ""
      warn "WARNING: ::Malamute::FFI is not available without libmlm."
      warn ""
      @available = false
    end


    def self.attach_function(name, *rest)
      super
    rescue ::FFI::NotFoundError
      define_singleton_method name do |*|
        raise NotImplementedError, "The function #{name}() is not provided by the Malamute library installed. Upgrade the library or compile it with --enable-drafts."
      end

      return unless $VERBOSE || $DEBUG

      warn "The function #{name}() is not provided by the installed Malamute library."
    end

    if available?
      opts = {
        blocking: true  # only necessary on MRI to deal with the GIL.
      }

      attach_function :mlm_proto_new, [], :pointer, **opts
      attach_function :mlm_proto_destroy, [:pointer], :void, **opts
      attach_function :mlm_proto_recv, [:pointer, :pointer], :int, **opts
      attach_function :mlm_proto_send, [:pointer, :pointer], :int, **opts
      attach_function :mlm_proto_print, [:pointer], :void, **opts
      attach_function :mlm_proto_routing_id, [:pointer], :pointer, **opts
      attach_function :mlm_proto_set_routing_id, [:pointer, :pointer], :void, **opts
      attach_function :mlm_proto_id, [:pointer], :int, **opts
      attach_function :mlm_proto_set_id, [:pointer, :int], :void, **opts
      attach_function :mlm_proto_command, [:pointer], :string, **opts
      attach_function :mlm_proto_address, [:pointer], :string, **opts
      attach_function :mlm_proto_set_address, [:pointer, :string], :void, **opts
      attach_function :mlm_proto_stream, [:pointer], :string, **opts
      attach_function :mlm_proto_set_stream, [:pointer, :string], :void, **opts
      attach_function :mlm_proto_pattern, [:pointer], :string, **opts
      attach_function :mlm_proto_set_pattern, [:pointer, :string], :void, **opts
      attach_function :mlm_proto_subject, [:pointer], :string, **opts
      attach_function :mlm_proto_set_subject, [:pointer, :string], :void, **opts
      attach_function :mlm_proto_content, [:pointer], :pointer, **opts
      attach_function :mlm_proto_get_content, [:pointer], :pointer, **opts
      attach_function :mlm_proto_set_content, [:pointer, :pointer], :void, **opts
      attach_function :mlm_proto_sender, [:pointer], :string, **opts
      attach_function :mlm_proto_set_sender, [:pointer, :string], :void, **opts
      attach_function :mlm_proto_tracker, [:pointer], :string, **opts
      attach_function :mlm_proto_set_tracker, [:pointer, :string], :void, **opts
      attach_function :mlm_proto_timeout, [:pointer], :uint32, **opts
      attach_function :mlm_proto_set_timeout, [:pointer, :uint32], :void, **opts
      attach_function :mlm_proto_status_code, [:pointer], :uint16, **opts
      attach_function :mlm_proto_set_status_code, [:pointer, :uint16], :void, **opts
      attach_function :mlm_proto_status_reason, [:pointer], :string, **opts
      attach_function :mlm_proto_set_status_reason, [:pointer, :string], :void, **opts
      attach_function :mlm_proto_amount, [:pointer], :uint16, **opts
      attach_function :mlm_proto_set_amount, [:pointer, :uint16], :void, **opts
      attach_function :mlm_proto_test, [:bool], :void, **opts

      require_relative 'ffi/mlm_proto'

      attach_function :mlm_client_new, [], :pointer, **opts
      attach_function :mlm_client_destroy, [:pointer], :void, **opts
      attach_function :mlm_client_actor, [:pointer], :pointer, **opts
      attach_function :mlm_client_msgpipe, [:pointer], :pointer, **opts
      attach_function :mlm_client_connected, [:pointer], :bool, **opts
      attach_function :mlm_client_set_plain_auth, [:pointer, :string, :string], :int, **opts
      attach_function :mlm_client_connect, [:pointer, :string, :uint32, :string], :int, **opts
      attach_function :mlm_client_set_producer, [:pointer, :string], :int, **opts
      attach_function :mlm_client_set_consumer, [:pointer, :string, :string], :int, **opts
      attach_function :mlm_client_remove_consumer, [:pointer, :string], :int, **opts
      attach_function :mlm_client_set_worker, [:pointer, :string, :string], :int, **opts
      attach_function :mlm_client_send, [:pointer, :string, :pointer], :int, **opts
      attach_function :mlm_client_sendto, [:pointer, :string, :string, :string, :uint32, :pointer], :int, **opts
      attach_function :mlm_client_sendfor, [:pointer, :string, :string, :string, :uint32, :pointer], :int, **opts
      attach_function :mlm_client_recv, [:pointer], :pointer, **opts
      attach_function :mlm_client_command, [:pointer], :string, **opts
      attach_function :mlm_client_status, [:pointer], :int, **opts
      attach_function :mlm_client_reason, [:pointer], :string, **opts
      attach_function :mlm_client_address, [:pointer], :string, **opts
      attach_function :mlm_client_sender, [:pointer], :string, **opts
      attach_function :mlm_client_subject, [:pointer], :string, **opts
      attach_function :mlm_client_content, [:pointer], :pointer, **opts
      attach_function :mlm_client_tracker, [:pointer], :string, **opts
      attach_function :mlm_client_sendx, [:pointer, :string, :string, :varargs], :int, **opts
      attach_function :mlm_client_sendtox, [:pointer, :string, :string, :string, :varargs], :int, **opts
      attach_function :mlm_client_sendforx, [:pointer, :string, :string, :string, :varargs], :int, **opts
      attach_function :mlm_client_recvx, [:pointer, :pointer, :pointer, :varargs], :int, **opts
      attach_function :mlm_client_set_verbose, [:pointer, :bool], :void, **opts
      attach_function :mlm_client_test, [:bool], :void, **opts

      require_relative 'ffi/mlm_client'
    end
  end
end

################################################################################
#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
#  Read the zproject/README.md for information about making permanent changes. #
################################################################################
