/*  =========================================================================
    mlm_classes - private header file

    Copyright (c) the Contributors as noted in the AUTHORS file.
    This file is part of the Malamute Project.

    This Source Code Form is subject to the terms of the Mozilla Public
    License, v. 2.0. If a copy of the MPL was not distributed with this
    file, You can obtain one at http://mozilla.org/MPL/2.0/.
################################################################################
#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
#  Read the zproject/README.md for information about making permanent changes. #
################################################################################
    =========================================================================
*/

#ifndef MLM_CLASSES_H_INCLUDED
#define MLM_CLASSES_H_INCLUDED

//  Platform definitions, must come first
#include "platform.h"

//  Asserts check the invariants of methods. If they're not
//  fulfilled the program should fail fast. Therefore enforce them!
#ifdef NDEBUG
  #undef NDEBUG
  #include <assert.h>
  #define NDEBUG
#else
  #include <assert.h>
#endif

//  External API
#include "../include/malamute.h"

//  Private external dependencies

//  Opaque class structures to allow forward references
#ifndef MLM_MSG_T_DEFINED
typedef struct _mlm_msg_t mlm_msg_t;
#define MLM_MSG_T_DEFINED
#endif
#ifndef MLM_STREAM_SIMPLE_T_DEFINED
typedef struct _mlm_stream_simple_t mlm_stream_simple_t;
#define MLM_STREAM_SIMPLE_T_DEFINED
#endif
#ifndef MLM_MAILBOX_BOUNDED_T_DEFINED
typedef struct _mlm_mailbox_bounded_t mlm_mailbox_bounded_t;
#define MLM_MAILBOX_BOUNDED_T_DEFINED
#endif
#ifndef MLM_MSGQ_T_DEFINED
typedef struct _mlm_msgq_t mlm_msgq_t;
#define MLM_MSGQ_T_DEFINED
#endif

//  Extra headers

//  Internal API

#include "mlm_msg.h"
#include "mlm_stream_simple.h"
#include "mlm_mailbox_bounded.h"
#include "mlm_msgq.h"

//  *** To avoid double-definitions, only define if building without draft ***
#ifndef MLM_BUILD_DRAFT_API

//  *** Draft method, defined for internal use only ***
//  Self test of this class.
MLM_PRIVATE void
    mlm_msg_test (bool verbose);

//  *** Draft method, defined for internal use only ***
//  Self test of this class.
MLM_PRIVATE void
    mlm_stream_simple_test (bool verbose);

//  *** Draft method, defined for internal use only ***
//  Self test of this class.
MLM_PRIVATE void
    mlm_mailbox_bounded_test (bool verbose);

//  Self test for private classes
MLM_PRIVATE void
    mlm_private_selftest (bool verbose, const char *subtest);

#endif // MLM_BUILD_DRAFT_API

#endif
